/* Generic Struct for loader task */
#ifndef __NLOAD_H__
#define __NLOAD_H__

#include "func.h" //Constant definition for loader and linux parser

struct loader_task {

  char name[20]; //Task name
  int task_type; //Tast type (OS,CT,BT)
  int contract; //Contract number
  int local_scheduler; //Local scheduler for the task
  int number; //How many copies of this task
  int group; //Group number
 
  struct timespec deadline; //Task deadline
  struct timespec wcet; //Task wcet
  
  int act_number; //Number of activations precalcolated
  int act_current; //Actual activation number

  int resource;
  int muxstatus;

  struct timespec *act; //Activation list
  struct timespec *exec; //Execution time list
  struct timespec *block; //Blocking time

};

struct loader_contract {

  int number; //Contract number
  struct timespec cmin;
  struct timespec tmax;
  struct timespec cmax;
  struct timespec tmin;
  int workload;
  struct timespec deadline;
  int local_scheduler;
  int server; //Server number linked to this contract

};

#endif

