/*
 * Project: S.Ha.R.K.
 *
 * Coordinators: 
 *   Giorgio Buttazzo    <giorgio@sssup.it>
 *   Paolo Gai           <pj@gandalf.sssup.it>
 *
 * Authors     : 
 *   Paolo Gai           <pj@gandalf.sssup.it>
 *   Massimiliano Giorgi <massy@gandalf.sssup.it>
 *   Luca Abeni          <luca@gandalf.sssup.it>
 *   (see the web pages for full authors list)
 *
 * ReTiS Lab (Scuola Superiore S.Anna - Pisa - Italy)
 *
 * http://www.sssup.it
 * http://retis.sssup.it
 * http://shark.sssup.it
 */

#ifndef __TRACE_QCIRC_H
#define __TRACE_QCIRC_H

#include "ll/sys/cdefs.h"

__BEGIN_DECLS

typedef struct TAGtrc_circular_queue_args_t {
  char *filename;
  int size;

  long period;
  long slice;
  
  int flags;
} TRC_CIRCULAR_PARMS;

#define TRC_CIRCULAR_ONLINETASK          0x0001

#define trc_circular_default_parms(m)    (m).filename=NULL,\
                                         (m).size=8192,\
					 (m).period=500000,\
					 (m).slice=25000,\
				         (m).flags=0
#define trc_circular_def_filename(m,s)   (m).filename=(s)
#define trc_circular_def_size(m,s)       (m).size=(s)
					 
#define trc_circular_def_onlinetask(m)   (m).flags|=TRC_CIRCULAR_ONLINETASK
#define trc_circular_def_period(m,p)     (m).period=p
#define trc_circular_def_slice(m,s)      (m).slice=s
					 
int trc_register_circular_queue(void);

__END_DECLS
#endif
