/*
 * Project: S.Ha.R.K.
 *
 * Coordinators: 
 *   Giorgio Buttazzo    <giorgio@sssup.it>
 *   Paolo Gai           <pj@gandalf.sssup.it>
 *
 * Authors     : 
 *   Paolo Gai           <pj@gandalf.sssup.it>
 *   Massimiliano Giorgi <massy@gandalf.sssup.it>
 *   Luca Abeni          <luca@gandalf.sssup.it>
 *   (see the web pages for full authors list)
 *
 * ReTiS Lab (Scuola Superiore S.Anna - Pisa - Italy)
 *
 * http://www.sssup.it
 * http://retis.sssup.it
 * http://shark.sssup.it
 */

#ifndef __TRACE_QFIXED_H
#define __TRACE_QFIXED_H

#include "ll/sys/cdefs.h"

__BEGIN_DECLS

typedef struct TAGtrc_fixed_queue_args_t {
  char *filename;
  int size;
} TRC_FIXED_PARMS;

#define trc_fixed_default_parms(m)  (m).filename=NULL,\
                                    (m).size=8192
#define trc_fixed_def_filename(m,s) (m).filename=(s)
#define trc_fixed_def_size(m,s)     (m).size=(s)

/* Fixed queue, FAT16 filesystem (see kernel/modules/trcfixed.c) */
int trc_register_fixed_queue(void);

/* Fixed queue, DOSFS filesystem (see kernel/modules/trcdfix.c) 
   Note: You MUST specify a valid filename... */
int trc_register_dosfs_fixed_queue(void);

__END_DECLS
#endif

